#ifndef _Cpptcl_cpptclcompilers_
#define _Cpptcl_cpptclcompilers_

#ifndef __WIN32__
#   if defined(_WIN32) || defined(WIN32)
#	define __WIN32__
#   endif
#endif

#if defined(__WIN32__)
/*
 * VC++ has an alternate entry point called DllMain, so we need to rename
 * our entry point.
 */
	#   define WIN32_LEAN_AND_MEAN
	#   include <windows.h>
	#   undef WIN32_LEAN_AND_MEAN
	#   if defined(_MSC_VER)
		#	define EXPORT(a,b) __declspec(dllexport) a b
		#	define DllEntryPoint DllMain
	#   else
		#	if defined(__BORLANDC__)
		#	    define EXPORT(a,b) a _export b
		#	else
		#	    define EXPORT(a,b) a b
		#	endif
	#   endif
	#define CPPTCL_PLATFORM_ENTRY \
	BOOL APIENTRY \
	DllEntryPoint(HINSTANCE hInst, DWORD reason, LPVOID reserved); \
	BOOL APIENTRY \
	DllEntryPoint(HINSTANCE, DWORD, LPVOID) { \
		return TRUE; \
	}
	// Microsoft define the most obnoxious macros
	#ifdef min
	#undef min
	#endif
	#ifdef max
	#undef max
	#endif
	#ifdef __MWERKS__  // MetroWerks CodeWarrior Pro
		#define NO_EXCEPTION_HANDLING
	#endif
	//EXTERN EXPORT(int,Example_Init) _ANSI_ARGS_((Tcl_Interp *interp));
	//EXTERN EXPORT(int,Example_SafeInit) _ANSI_ARGS_((Tcl_Interp *interp));
#else
	// Not Windows: i.e. Unix or MacOS
	#   define EXPORT(a,b) a b
	#define CPPTCL_PLATFORM_ENTRY
	#ifdef __MWERKS__  // MetroWerks CodeWarrior Pro
		// MacOS
		#include "MW_CpptclHeader.h"
		#define MSL_USE_PRECOMPILED_HEADERS 0
		#define NO_EXCEPTION_HANDLING
	#endif
#endif


#if defined(__WIN32__)
	#ifndef DLL_EXPORT
	#define DLL_EXPORT __declspec(dllexport)
	#endif
	#ifndef DLL_IMPORT
	#define DLL_IMPORT __declspec(dllimport)
	#endif
#else
	// Not Windows: i.e. Unix or MacOS
	#ifndef DLL_EXPORT
	#define DLL_EXPORT 
	#endif
	#ifndef DLL_IMPORT
	#define DLL_IMPORT 
	#endif
#endif

#endif

